using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;
using System.IO;

using Microsoft.BizTalk.ExplorerOM;
using Microsoft.BizTalk.Deployment;
using Microsoft.BizTalk.Component.Interop;
using System.Diagnostics;

namespace BizTalkBill.BizTalkHelpers
{

    public class Orchestration
    {
        public static ArrayList SplitString(string sString, char sSplit)
        {
            return new ArrayList(sString.Split(sSplit));
        }
        public static string GetArrayItem(ArrayList alList, Int32 nPosition)
        {
            return alList[nPosition].ToString();
        }
        public static string ExtractFileName(string sFullFileName)
        {
            FileInfo fiFile = new FileInfo(sFullFileName);
            return fiFile.Name;
        }
        public static string ExtractDirectory(string sFullFileName)
        {
            FileInfo fiFile = new FileInfo(sFullFileName);
            return fiFile.DirectoryName;
        }

        public static string ExtractLastDirectory(string sFullFileName)
        {
            string sResult = "";
            FileInfo fiFile = new FileInfo(sFullFileName);
            string sPath = fiFile.DirectoryName;

            if (sPath.EndsWith(@"\"))
            {
                sPath = sPath.Substring(0, sPath.Length - 2);
            }

            if (sPath.LastIndexOf(@"\") > 0)
            {
                sResult = sPath.Substring(sPath.LastIndexOf(@"\") + 1);
            }

            return sResult;
        }
        private static string m_BizTalkGroupName = "";

        public static string GetBizTalkGroupName()
        {
            ConfigurationDatabase cdb = null;
            BtsCatalogExplorer explorer = null;

            if (m_BizTalkGroupName == "")
            {
                // create a ConfigurationDatabase instance because that class sets the connection string
                // we want to use
                try
                {
                    cdb = new ConfigurationDatabase();

                    explorer = new BtsCatalogExplorer();

                    // assign the connection string, effectively connecting to the database
                    // TODO: optimize this if used frequently to cache the connection
                    explorer.ConnectionString = cdb.Database.Length == 0 ? "Integrated Security=SSPI; Persist Security Info=false; Server=(local); Database=BizTalkMgmtDb;" : cdb.ConnectionString;

                    m_BizTalkGroupName = explorer.GroupName;
                }
                catch (Exception ex1)
                {
                    Debugging.WriteEventLog("BizTalkHelpers", "Error Connecting to BizTalkCatalogExplorer = " + ex1.ToString(), EventLogEntryType.Warning);
                }
                finally
                {
                    if (explorer != null)
                        explorer.Dispose();
                    if (cdb != null)
                        cdb.Dispose();
                }
            }

            return m_BizTalkGroupName;
        }
    }
}
